secure: can only work for IPv4, so assert on it